function [D] = PSDirctionSet1(n,v,beta,dsn)
% PS pruned direction set in case of getting a descent direction
% **********************************************
% Pruning Type 1
if (dsn == 1)   
    A=eye(n); D=A;
    for i=1:n;
        for j=1:n;
            D(i,j+n)=-A(i,j);
        end
    end
% **********************************************  
% Pruning Type 2
elseif (dsn == 2)
    D=eye(n);
    for j=1:n; D(j,n+1)=-1; end   
% **********************************************
% Pruning Type 3
elseif (dsn == 3)
    A=eye(n); D1=A;
    for i=1:n;
        for j=1:n;
            D1(i,j+n)=-A(i,j);
        end
    end
    m=0;
    for j=1:2*n
        ip=0;
        for i=1:n; ip=ip+v(i)*D1(i,j); end
        if ip>=norm(v)*beta;
            m=m+1;
            for k=1:n;
                D(k,m)=D1(k,j);
            end
        end
    end
% ********************************************** 
% Pruning Type 4
elseif (dsn == 4)
    m=n;
    in=0;
    for i=1:n; 
        if (v(i) <= 0); m=m-1; end
        if (v(i) < 0 & in == 0); in=in+1; end        
    end
    if (in > 0); m=m+1; end
    D=zeros(n,m);
    if (in > 0); for i=1:n; D(i,m)=-1; end; end
    ii=0;    
    for i=1:n;        
        if (v(i) > 0)
            ii=ii+1;
            D(i,ii)=1;
        end
    end
% ********************************************** 
% Pruning Type 5
elseif (dsn == 5)
    D=zeros(n,1);
	for i=1:n; 
        if (abs(v(i)) >= abs(max(v)) & abs(v(i)) >= abs(min(v)) );
            D(i)=sign(v(i));
        end
    end
% **********************************************
% Pruning Type 6
elseif (dsn == 6)
    D=zeros(n,1);
    abs_v=abs(v);
    nz=0;
    for i=1:n; 
        if (v(i) == 0); nz=nz+1; 
        else 
            nzi=i;
        end; 
    end
    if (nz == n-1);
        D(nzi)=1;
    else
        DD=zeros(n,n-nz);
        min_nz=max(abs_v);
    end
% **********************************************
% Pruning Type 7
elseif (dsn == 7)
    D=zeros(n,1);
	for i=1:n; 
        D(i,1)=sign(v(i));        
	end
end
% ***************************************************