function [D] = PSDirctionSet2(n,v,beta,dsn)
% PS pruned direction set in case of not getting a descent direction
% **********************************************
% Pruning Type 1
if (dsn == 1) 
    A=eye(n); D1=A;
    for i=1:n;
        for j=1:n;
            D1(i,j+n)=-A(i,j);
        end
    end
    m=0;
    for j=1:2*n
        ip=0;
        for i=1:n; ip=ip+v(i)*D1(i,j); end
        if ip<=-norm(v)*beta;
            m=m+1;
            for k=1:n;
                D(k,m)=D1(k,j);
            end
        end
    end
% ***********************************************
% Pruning Type 2
elseif (dsn == 2)
    iz=0;
    in=0;
    for i=1:n; 
        if (v(i) == 0); iz=iz+1; end
        if (v(i) < 0 ); in=in+1; end        
    end
    if (in == n); 
        D=eye(n);
    else
        D=zeros(n,in+1);
        ii=0;
        for i=1:n; 
            if (v(i) < 0 ); 
                ii=ii+1;
                D(i,ii)=1;                
            end        
            D(i,in+1)=-1;
        end           
    end        
end